<?php
// $Id: subdomain_mode_term.inc,v 1.1.2.3 2010/09/06 09:29:16 setvik Exp $

/**
 * @file
 * Subdomain engine term mode subclass
 */


/**
 * Description of subdomain_term
 *
 * @author setvik
 */
class subdomain_mode_term extends subdomain_engine {

  function type() {
    return 'term';
  }

  function base_path($sid) {
    return 'taxonomy/term/'. $sid;
  }

  function is_entry_form($form_id) {
    return $form_id == 'taxonomy_form_term';
  }

  function get_content_subdomain($nid) {
    static $subdomains;
    if (!isset($subdomains[$nid])) {
      // Get first group_nid
      $vid = variable_get('subdomain_vocab', '');
      $sid = db_result(db_query("SELECT tn.tid
        FROM {term_node} tn
        INNER JOIN {node} n on tn.vid = n.vid
        INNER JOIN {term_data} td on tn.tid = td.tid
        WHERE td.vid = %d AND n.nid = %d", $vid, $nid));
      $subdomains[$nid] = subdomain_get_subdomain($sid);
    }
    return $subdomains[$nid];
  }

  function entry_form_alter(&$form, $form_id) {
    if ($form['#vocabulary']['vid'] == variable_get('subdomain_vocab', 0)
    && !($form['delete']['#type'] == 'value' && $form['delete']['#value'] == TRUE)) {
      $default = subdomain_get_subdomain($form['tid']['#value']);
      $form['subdomain_exists'] = array(
        '#type' => 'value',
        '#value' => !empty($default),
      );

      if ($this->source == 'custom') {
        $form['identification']['name']['#weight'] = -5.1;

        $editable = user_access('edit any subdomains') || user_access('edit own subdomains');
        $form['identification']['subdomain'] = _subdomain_get_custom_form_field($default, $editable);
      }
      _subdomain_add_js_validation($form['tid']['#value']);
    }
  }

  function save($term) {
    if ($term['vid'] == variable_get('subdomain_vocab', 0)) {
      $this->save_record($term['tid'], $term[$this->form_field], !$term['subdomain_exists']);
    }
  }

  function delete($term) {
    if ($term['vid'] == variable_get('subdomain_vocab', 0)) {
      $this->delete_record($term['tid']);
    }
  }

  function url_outbound_helper(&$subdomain, &$path, $original_path, &$is_system_path) {
    if ($tid = _subdomain_id_from_path('tid', $original_path)) {
      $subdomain = subdomain_get_subdomain($tid);
      if (!empty($subdomain) && $path == $this->base_path($tid)) {
        $path = '';
      }
    }
    elseif ($nid = _subdomain_id_from_path('nid', $original_path)) {
      $subdomain = subdomain()->get_content_subdomain($nid);
    }
    else {
      $is_system_path = TRUE;
    }
  }
}