<?php
// $Id: subdomain_mode_user.inc,v 1.1.2.3 2010/09/06 09:29:16 setvik Exp $

/**
 * @file
 * Subdomain engine user mode subclass
 */


/**
 * Description of subdomain_user
 *
 * @author setvik
 */
class subdomain_mode_user extends subdomain_engine {

  function type() {
    return 'user';
  }

  function base_path($sid) {
    return 'user/'. $sid;
  }

  function is_entry_form($form_id) {
    return in_array($form_id, array('user_register', 'user_profile_form'));
  }

  function get_content_subdomain($nid) {
    static $subdomains;
    if (!isset($subdomains[$nid])) {
      $subdomains[$nid] = db_result(db_query("SELECT subdomain FROM {subdomain} s INNER JOIN {node} n ON s.sid = n.uid WHERE nid = %d", $nid));
    }
    return $subdomains[$nid];
  }

  function entry_form_alter(&$form, $form_id) {
    global $user;

    $default = subdomain_get_subdomain($form['_account']['#value']->uid);
    $form['subdomain_exists'] = array(
      '#type' => 'value',
      '#value' => !empty($default),
    );

    if ($this->source == 'custom') {
      if (isset($form['account'])) {
        $parent = &$form['account'];
      }
      else {
        $parent = &$form;
      }
      $parent['name']['#weight'] = -5.1;

      $editable = $form_id == 'user_register'
        || user_access('edit any subdomains')
        || (user_access('edit own subdomains') && $user->uid == $form['#uid']);
      $parent['subdomain'] = _subdomain_get_custom_form_field($default, $editable);
    }
    _subdomain_add_js_validation($form['#uid']);
  }

  function save($user) {
    $this->save_record($user['uid'], $user[$this->form_field], !$user['subdomain_exists']);
  }

  function delete($user) {
    $this->delete_record($user->uid);
  }

  function url_outbound_helper(&$subdomain, &$path, $original_path, &$is_system_path) {
    if ($uid = _subdomain_id_from_path('uid', $original_path)) {
      $subdomain = subdomain_get_subdomain($uid);
      if (!empty($subdomain) && $path == $this->base_path($uid)) {
        $path = '';
      }
    }
    elseif ($nid = _subdomain_id_from_path('nid', $original_path)) {
      $subdomain = subdomain()->get_content_subdomain($nid);
    }
    else {
      $is_system_path = TRUE;
    }
  }
}